Foreman - Feature #832

parameterized class support
04/12/2011 02:42 PM - Ashley Penney

Status: Closed

Priority: Normal

Assignee: Ohad Levy

Category: Puppet integration

Target version: 1.1

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:

Pull request:

Description

http://projects.puppetlabs.com/issues/5045 is the ticket for this.

Basically | think the Ul should be updated so that when you select a class it either gives you the parameters directly below or creates

new boxes (like the existing parameters one) below that list:

Class name:
Parameter name [ box to typein ]
Parameter name 2 [ box to type in ]

Related issues:

Related to Foreman - Feature #1165: Host details should display inherited hos... Closed
Related to Foreman - Feature #1028: Ability to edit custom fields in the host... Closed
Related to Foreman - Feature #1995: Enable parameterized class support by def... Closed

09/13/2011
07/06/2011
12/04/2012

Associated revisions

Revision f8d94608 - 09/24/2012 10:41 AM - Amos Benari

fixes #832 - adds parameterized class support

Credits:
This patch is based on the original work of Olivier Favre

<olivier@yakaz.com> many many thanks!

This patch adds the following features

e import class parameters, and try to understand their types
e support a complex matrix of environments, puppet classes and their
signature - each class can have a different set of parameters per environment.
e adds an ignore yaml file 'config/ignored_environments.yml.sample' file were
users can add regexp or class names that the importer should ignore.
common usage case for this is classes such as ::config, ::install etc.
introduce a new type of smart variable - parameterized.
adds complex data types to smart vars, arrays, hashes, json, yaml etc are all supported now.

in order to use the new ENC format for puppet 2.6.5+ you should enable the
Parametrized_Classes_in_ENC and Enable_Smart_Variables_in_ENC within Foreman Settings

This is the initial patch just to get param classes support in, follow-up patches
would include a better Ul and the relevant Ul updates to host edit page etc.

Signed-off-by: Ohad Levy <ohadlevy@gmail.com>

Revision 75bd351e - 09/26/2012 12:15 AM - Ohad Levy

refs #832 - making sure that ENC values cast - skipped this patch somehow

Revision 77a8080a - 10/03/2012 11:44 AM - Ohad Levy

refs #832 do not force smartvars order saved if they are the default or not sent over the wire.
History

#1 - 05/24/2011 11:55 AM - Romain Vrignaud

+1 It would be very usefull !

#2 - 09/15/2011 04:41 PM - Ignace Mouzannar

| agree, this would be greatly useful.

| there a way to take advantage of puppet's parameterized classes via Foreman's ENC (even if it isn't supported in GUI yet)?

#3 - 11/09/2011 11:54 AM - Romain Vrighaud

For me, the use case should be :

e After importing puppet classes, | should be able to edit class and in a "Parameterized Class" Tab | should be able to add as many paramaters as
| want and optional default value for each parameter.

e When | edit an hostgroup and | add a parameterized class to this hostgroup : it should show under the list class (or in parameter tab ?) the list of
declared paramater for that class and | should be able to edit the keys. If | don't set any value then it should be mandatory to be done during host
edition.

¢ In the same idea, If | add a parameterized class to an host, | should be able to configure the parameterized class in the same way.

e If one of my host is declared as a member of an hostgroup which include a parameterized class, | should see the value affected in hostgroup.
(see Feature #1165)

#4 - 01/29/2012 11:23 AM - James Kerby

There was an IRC meetup to discuss this issue in December. Does anyone have any feedback on that discussion and whether this will be
implemented anytime soon?

#5 - 04/16/2012 10:42 PM - Glen Ogilvie

Any progress on this? | see that ticket 5045, has been merged, so puppet itself supports parameterized classes from an external node classifier.
Maybe this could go into foreman release 0.5?

#6 - 04/17/2012 03:54 AM - James Kerby

Yes, we've been kicking our heels waiting for puppet to support this. It would be great in Foreman could get this into 0.5

#7 - 06/29/2012 09:07 AM - Olivier Favre

- Assignee set to Olivier Favre

#8 - 07/03/2012 04:55 AM - Ohad Levy

you can track progress here https:/github.com/yakaz/foreman/commits/fix832/

#9 - 07/22/2012 03:14 PM - Ohad Levy

- Target version set to 1.1

#10 - 09/19/2012 04:20 PM - Ohad Levy
- Category set to Puppet integration

- Assignee changed from Olivier Favre to Ohad Levy

a more recent hopefully soon to be merged here:

https://github.com/ohadlevy/foreman/tree/class_params

#11 - 09/24/2012 10:49 AM - Amos Benari
- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset {8d946082e58b60213a27ded3e1e5f5373d976de.
